(in-package :cffi-test)

;; Cannot use CFFI:USE-FOREIGN-LIBRARY because ECL wasn't build with
;; DFFI. Using FFI:LOAD-FOREIGN-LIBRARY instead.
;;
;; Do we need to tell CFFI that we use libm? Loading a library seems
;; incorrect if we aren't using DFFI. Anyway, with or without this
;; loading, it doesn't work.
#-(or ming32 windows)
(ffi:load-foreign-library #+darwin "/usr/lib/libm.dylib"
						  #-darwin "/usr/lib/libm.so")

;; According to the ECL manual, there are problems if we use a
;; function without declaring it. Let's declare "sin"
(cffi:defcfun ("sin" c-sine) :double '(:double))

;; Also, let's try using CFFI:FOREIGN-FUNCALL.
(defun ff-c-sine (f)
  "invokes C function sin"
  (cffi:foreign-funcall "sin" :double f :double))